// StictIsSlow - comparing VB.Net and C# performance
// Copyright 2002-2003 by Dan Appleman
using System;
using System.Collections;
using System.Diagnostics;

namespace PerfCS
{
	class Class1
	{

		static ArrayList TestArray;

		static void Perf2() 
		{
			int x, loops;

			TimeSpan StartTime;
			TimeSpan Duration;
			String Result;

			GC.Collect();
			GC.WaitForPendingFinalizers();
			StartTime = Process.GetCurrentProcess().Threads[0].UserProcessorTime;

			for(loops = 1; loops<5000; loops++) 
			{
				for(x = 0; x<= 9999; x++) 
				{
					Result = TestArray[x].ToString();
				}
			}

	        Duration = Process.GetCurrentProcess().Threads[0].UserProcessorTime.Subtract(StartTime);
		    Console.WriteLine ("Total time is: " + Duration.ToString());
		}


		[STAThread]
		static void Main(string[] args)
		{
			TestArray = new ArrayList(10000);
			int x;
			for(x=0;x<10000;x++) 
			{
				TestArray.Add(x.ToString());
			}
			Perf2();
			Console.ReadLine();
		}
	}
}
