' String examination demo program
' Copyright 2002-2003 by Dan Appleman
Imports System.Runtime.InteropServices
Module Module1

    Sub Main()
        Dim x As Integer
        Dim s1 As String = "Hello"
        Dim s2 As String = s1
        If s1 Is s2 Then Console.WriteLine("s1 and s2 are Same object")
        Mid$(s1, 1, 1) = "J"
        Console.WriteLine(s1)
        Console.Write(s2)
        Console.ReadLine()
        ' We can look at the actual data
        s1 = "Hello"
        s2 = s1
        Dim gch As GCHandle = GCHandle.Alloc(s1, GCHandleType.Pinned)
        Dim i As IntPtr
        i = gch.AddrOfPinnedObject()
        Dim DataArray(9) As Byte
        Marshal.Copy(i, DataArray, 0, 10)
        Console.WriteLine("Contents of pinned string")
        For x = 0 To 9
            Console.Write(DataArray(x).ToString & " ")
        Next
        Console.ReadLine()
        ' The following causes SERIOUS problems
        DataArray(0) += 2
        Console.WriteLine("Before and after modifying pinned s1")
        Console.WriteLine(s1)
        Console.WriteLine(s2)
        Marshal.Copy(DataArray, 0, i, 10)
        If s1 Is s2 Then Console.WriteLine("s1 and s2 are Same object")
        Console.WriteLine(s1)
        Console.WriteLine(s2)
        Dim s3 As String = "Hello"
        Console.WriteLine(s3)
        gch.Free()
        Console.ReadLine()
        ' If you need to get an unmanaged buffer, try this
        s1 = "Hello2"
        s2 = s1
        i = Marshal.StringToHGlobalUni(s1)
        Console.WriteLine("Contents of s1 marshaled to unmanaged heap")
        Marshal.Copy(i, DataArray, 0, 10)
        For x = 0 To 9
            Console.Write(DataArray(x).ToString & " ")
        Next
        Console.ReadLine()
        DataArray(0) += 2
        Console.WriteLine(s1)
        Console.WriteLine(s2)
        Marshal.Copy(DataArray, 0, i, 10)
        s1 = Marshal.PtrToStringUni(i)
        If Not s1 Is s2 Then Console.WriteLine("s1 and s2 are not Same object")
        Console.WriteLine(s1)
        Console.WriteLine(s2)
        Marshal.FreeHGlobal(i)
        Console.ReadLine()
    End Sub

End Module
