using System;
using System.Collections;
using System.Globalization;

namespace WhatDayIsItCS
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			//
			// TODO: Add code to start application here
			//
			ArrayList Calendars = new ArrayList();
			Calendars.Add(new GregorianCalendar());
			Calendars.Add(new HebrewCalendar());
			Calendars.Add(new HijriCalendar());
			Calendars.Add(new JapaneseCalendar());
			Calendars.Add(new JulianCalendar());
			Calendars.Add(new KoreanCalendar());
			Calendars.Add(new TaiwanCalendar());
			Calendars.Add(new ThaiBuddhistCalendar());

			Calendar ACalendar ;
			Console.WriteLine("Today is: ");
			foreach(Calendar CurrentCalendar in Calendars) 
			{
				Console.WriteLine(CurrentCalendar.ToString());
				Console.Write(System.Enum.Format(typeof (DayOfWeek), CurrentCalendar.GetDayOfWeek(DateTime.Now ), "G") + " ");
				Console.Write(CurrentCalendar.GetMonth(DateTime.Now).ToString() + "/" + CurrentCalendar.GetDayOfMonth(DateTime.Now) + "/" + CurrentCalendar.ToFourDigitYear(CurrentCalendar.GetYear(DateTime.Now)) + " era: " + CurrentCalendar.GetEra(DateTime.Now));
				Console.WriteLine();
			}
			Console.WriteLine();
			ACalendar = CultureInfo.CurrentUICulture.Calendar;
			Console.WriteLine("Your default calendar is: " + ACalendar.ToString() + " type: " + System.Enum.GetName(typeof(GregorianCalendarTypes), ((GregorianCalendar)ACalendar).CalendarType));
			Calendar[] OtherCalendars ;
			OtherCalendars = CultureInfo.CurrentUICulture.OptionalCalendars;
			if (OtherCalendars != null) 
			{
				Console.WriteLine("Your optional calendars are: ");
				foreach(Calendar CurrentCalendar in OtherCalendars) 
				{
					if (CurrentCalendar is GregorianCalendar) 
					{
						Console.WriteLine(CurrentCalendar.ToString() + " type: " + System.Enum.GetName(typeof(GregorianCalendarTypes), ((GregorianCalendar)CurrentCalendar).CalendarType ));
					}
					else 
					{
						Console.WriteLine(CurrentCalendar.ToString());
					}
				}

				Console.ReadLine();
			}
		}
	}
}
